#!/usr/bin/perl -w
# -*- cperl -*-
use strict;

##
## sinus via PWM und lookup table
##
## wir brauchen nur die daten fuer 1/4 welle, der rest wird berechnet.
##
## annahme:
## basis-ton 440Hz
## PWM 8kHz
## freq-unterschiede 2.2, 6, 11.1, 14.4 Hz
##
## generating pink noise: http://www.firstpr.com.au/dsp/pink-noise/
## http://home.earthlink.net/%7Eltrammell/tech/pinkalg.htm

my $pi = 3.1415926;
my $lutsz = 256; # LUT size

print "/* sine look up table with $lutsz entries, generated by $0 */\n";
print "#define SINE_LUT_SIZE $lutsz\n";
print "const uint8_t sine_lut[] PROGMEM = {\n";

for my $i (0..$lutsz-1) {
  printf("  %.0f,\n", 127 * sin($i*$pi/2/$lutsz));
}

print "};\n";
